> ## Documentation Index
> Fetch the complete documentation index at: https://docs.kibocommerce.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Type Ahead Search

> Searches the items displayed on the storefront.



## OpenAPI

````yaml /openapi/openapi_catalog_storefront.json get /commerce/catalog/storefront/productsearch/visualsearch
openapi: 3.0.1
info:
  description: |-
    <div id="overview_CATALOG_STOREFRONT">
                <h2>CATALOG STOREFRONT</h2>
                <p>The Catalog Storefront APIs are a collection of resources for managing storefront categories, currencies, price lists, products, and
                    product search. This controls how the products in your catalog are organized and displayed on the
                    storefront. See the
                    <a href="/concept-guides/catalog">Catalog user guides</a>
                    for information about the related features in the Unified Commerce Admin.</p>
                <p>Use the <strong>Currencies</strong> resource to retrieve exchange rates for displaying prices on your storefront.</p>
                <p>Use the <strong>Storefront Categories</strong> resource to view the product category hierarchy as it appears to shoppers
                    who are browsing the storefront. The hierarchy can be returned as a flat list or as a category tree.</p>
                <p>Use the <strong>Pricelists</strong> resource to retrieve the details of a price list. The details may contain a hierarchy
                    of ancestor and/or descendant price lists dependening on your configuration.</p>
                <p>Use the <strong>Storefront Products</strong> resource to manage the shopper product selection process during a visit to
                    the web storefront. You can update product options as shoppers pick and choose their product choices. A
                    shopper cannot add a product to a cart until all of its required options have been selected.</p>
                <p>Use the <strong>Product Search</strong> resource to provide dynamic search results to shoppers as they browse and search
                    for products on the web storefront, and to suggest possible search terms as the shopper enters text. The related <strong>Search Redirect</strong>
                    resource allows you to retrieve any search redirect items.</p>
            </div>
  title: Catalog Storefront
  version: 0.0.1
servers:
  - description: Kibo Base URL
    url: '{baseUrl}/api'
    variables:
      baseUrl:
        default: https://t1000000.sb.usc1.gcp.kibocommerce.com
        description: Base URL
security:
  - bearerAuth: []
paths:
  /commerce/catalog/storefront/productsearch/visualsearch:
    get:
      tags:
        - ProductSearch
      summary: Type Ahead Search
      description: Searches the items displayed on the storefront.
      parameters:
        - in: query
          name: SearchTerm
          required: true
          schema:
            minLength: 2
            type: string
        - in: query
          name: Filters
          schema:
            items:
              $ref: '#/components/schemas/RequestFilter'
            type: array
        - in: query
          name: Returnfields
          schema:
            items:
              type: string
            type: array
        - in: query
          name: Searchfields
          schema:
            items:
              type: string
            type: array
        - in: query
          name: Ignoregrouping
          schema:
            type: boolean
        - in: query
          name: NumResults
          schema:
            format: int32
            maximum: 10000
            minimum: 1
            type: integer
        - in: query
          name: PageNumber
          schema:
            format: int32
            maximum: 1000
            minimum: 1
            type: integer
        - in: query
          name: ApplicationId
          schema:
            maxLength: 50
            minLength: 1
            type: string
        - in: query
          name: CatalogId
          schema:
            maxLength: 50
            minLength: 1
            type: string
        - in: query
          name: SessionId
          schema:
            maxLength: 100
            type: string
        - in: query
          name: TrackingId
          schema:
            maxLength: 100
            type: string
        - in: query
          name: ApiKey
          schema:
            type: string
        - in: query
          name: Revision
          schema:
            type: string
        - in: query
          name: Cip
          schema:
            type: string
        - in: query
          name: DisplayDebug
          schema:
            type: boolean
        - description: limits which fields are returned in the response body
          in: query
          name: responseFields
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/VisualSearchResult'
            text/json:
              schema:
                $ref: '#/components/schemas/VisualSearchResult'
            text/plain:
              schema:
                $ref: '#/components/schemas/VisualSearchResult'
          description: OK
components:
  schemas:
    RequestFilter:
      properties:
        name:
          nullable: true
          type: string
        values:
          items:
            type: string
          nullable: true
          type: array
      type: object
    VisualSearchResult:
      properties:
        pageId:
          nullable: true
          type: string
        results:
          items:
            additionalProperties: {}
            type: object
          nullable: true
          type: array
        trackingId:
          nullable: true
          type: string
      type: object
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      description: JWT Authorization header using the Bearer scheme.
      scheme: bearer
      type: http

````